searchNodes=[{"doc":"This is the documentation for the Griffin project. By default, Griffin will scan for content in the priv/content directory and output generated files to the _site directory. Griffin depends on the following libraries: Plug - a specification and conveniences for composable modules in between web applications","ref":"Griffin.html","title":"Griffin","type":"module"},{"doc":"Griffin Cowboy Plug to serve files from the output directory","ref":"Griffin.Web.Plug.html","title":"Griffin.Web.Plug","type":"module"},{"doc":"Simple route that serves files from the configured Griffin output directory.","ref":"Griffin.Web.Plug.html#call/2","title":"Griffin.Web.Plug.call/2","type":"function"},{"doc":"","ref":"Griffin.Web.Plug.html#init/1","title":"Griffin.Web.Plug.init/1","type":"function"},{"doc":"Creates a new Griffin project. It expects the path of the project as an argument. $ mix grf.new PATH A project at the given PATH will be created. Options --input-path - configures Griffin to search for source files on a given path --output-path - configures Griffin to write generated files to a given path -v , --version - prints the Griffin installer version Installation mix grf.new by default prompts you to fetch and install your dependencies. You can enable this behaviour by passing the --install flag or disable it with the --no-install flag. Examples $ mix grf.new blog Is equivalent to: $ mix grf.new blog --input-path priv/src --output-path _site","ref":"Mix.Tasks.Grf.New.html","title":"Mix.Tasks.Grf.New","type":"task"},{"doc":"Generates a new Markdown page with relevant front matter attributes. $ mix grf.gen.page PATH [--title TITLE] A Markdown file will be created with the name at the specified path with the default metadata fields: title , date and draft . Options --title - the page title. Defaults to _site","ref":"Mix.Tasks.Grf.New.Page.html","title":"Mix.Tasks.Grf.New.Page","type":"task"},{"doc":"Starts the application by configuring all endpoints servers to run. Note: to start the endpoint without using this mix task you must set server: true in your Phoenix.Endpoint configuration. Command line options --open - open browser window for each started endpoint Furthermore, this task accepts the same command-line options as mix run . For example, to run phx.server without recompiling: $ mix phx.server --no-compile The --no-halt flag is automatically added. Note that the --no-deps-check flag cannot be used this way, because Mix needs to check dependencies to find phx.server . To run phx.server without checking dependencies, you can run: $ mix do deps.loadpaths --no-deps-check, phx.server","ref":"Mix.Tasks.Grf.Server.html","title":"Mix.Tasks.Grf.Server","type":"task"},{"doc":"Updates the Griffin project generator locally. $ mix local.grf Accepts the same command line options as archive.install hex grf_new .","ref":"Mix.Tasks.Local.Grf.html","title":"Mix.Tasks.Local.Grf","type":"task"},{"doc":"Griffin is a tool for building static websites from simple text files. Among many competitors, Griffin aims to be the preferred tool for Erlang and Elixir developers and its development follows two core values: simplicity and productivity. To get started, an introductory knowledge of Elixir is helpful. If you aren't familiar with Elixir, the official guides and the Elixir learning resources page are great starter resources. These guides provide an overview into the components that are part of Griffin. Here's a list of the pages in these guides: Introduction: the guide you are currently reading. It will cover how to start your first Griffin website and how to build and deploy it. Guides: in-depth guides covering the main components in Griffin and Griffin projects Alternatively, this documentation is also provided in epub format . Since Griffin is in active development, these guides may be out of date or incomplete. We make documentation a top priority and we welcome improvements to it. If you wish to contribute, please open an issue on the Griffin repository, making sure to follow our Code of Conduct . Let's install Griffin.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"In order to build a static website with Griffin, we will need a few dependencies installed in our Operating System: the Erlang VM and the Elixir programming language and other optional packages. Please take a look at this list and make sure to install anything necessary for your system. Having dependencies installed in advance can prevent frustrating problems later on.","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"Griffin is written in Elixir, and our application code will also be written in Elixir. To install Elixir, please see the official Installation Page for help. If we have just installed Elixir for the first time, we will need to install the Hex package manager as well. Hex is necessary to get a Griffin website running (by installing dependencies) and to install any extra dependencies we might need along the way. Here's the command to install Hex (If you have Hex already installed, it will upgrade Hex to the latest version): $ mix local.hex","ref":"installation.html#elixir-1-13-or-later","title":"Installation - Elixir 1.13 or later","type":"extras"},{"doc":"To check that we are on Elixir 1.13 or later, run: elixir -v Erlang/OTP 24 [erts-12.0.1] [source] [64-bit] [smp:16:16] [ds:16:16:10] [async-threads:1] [jit] Elixir 1.13.2 Once we have Elixir, we are ready to install the Griffin application generator: $ mix archive.install hex grf_new The grf.new generator is now available to generate new applications in the next guide, called Up and Running . The flags mentioned below are command line options to the generator; see all available options by calling mix help grf.new .","ref":"installation.html#griffin","title":"Installation - Griffin","type":"extras"},{"doc":"At the end of this section, you must have installed Elixir, Hex, and Griffin. Now that we have everything installed, let's create our first Griffin website and get up and running .","ref":"installation.html#summary","title":"Installation - Summary","type":"extras"},{"doc":"Let's get a Griffin website up and running as quickly as possible. Make sure you've followed the Installation Guide before reading on. We can run mix grf.new from any directory in order to bootstrap our Griffin application. Griffin will accept either an absolute or relative path for the directory of our new project. Assuming that the name of our application is blog , let's run the following command: $ mix phx.new blog To learn more about mix phx.new you can read the Mix Tasks Guide . mix phx.new blog * creating blog/config/config.exs * creating blog/config/dev.exs * creating blog/config/prod.exs ... Fetch and install dependencies? [Yn] Phoenix generates the directory structure and all the files we will need for our application. Phoenix promotes the usage of git as version control software: among the generated files we find a .gitignore . We can git init our repository, and immediately add and commit all that hasn't been marked ignored. When it's done, it will ask us if we want it to install our dependencies for us. Let's say yes to that. Fetch and install dependencies? [Yn] Y * running mix deps.get * running mix deps.compile We are almost there! The following steps are missing: $ cd hello Then configure your database in config/dev.exs and run: $ mix ecto.create Start your Phoenix app with: $ mix phx.server You can also run your app inside IEx (Interactive Elixir) as: $ iex -S mix phx.server Once our dependencies are installed, the task will prompt us to change into our project directory and start our application. Phoenix assumes that our PostgreSQL database will have a postgres user account with the correct permissions and a password of &quot;postgres&quot;. If that isn't the case, please see the Mix Tasks Guide to learn more about the mix ecto.create task. Ok, let's give it a try. First, we'll cd into the hello/ directory we've just created: $ cd hello Now we'll create our database: $ mix ecto.create Compiling 13 files (.ex) Generated hello app The database for Hello.Repo has been created In case the database could not be created, see the guides for the mix ecto.create for general troubleshooting. Note: if this is the first time you are running this command, Phoenix may also ask to install Rebar. Go ahead with the installation as Rebar is used to build Erlang packages. And finally, we'll start the Phoenix server: $ mix phx.server [info] Running HelloWeb.Endpoint with cowboy 2.9.0 at 127.0.0.1:4000 (http) [info] Access HelloWeb.Endpoint at http://localhost:4000 [watch] build finished, watching for changes... ... If we choose not to have Phoenix install our dependencies when we generate a new application, the mix phx.new task will prompt us to take the necessary steps when we do want to install them. Fetch and install dependencies? [Yn] n We are almost there! The following steps are missing: $ cd hello $ mix deps.get Then configure your database in config/dev.exs and run: $ mix ecto.create Start your Phoenix app with: $ mix phx.server You can also run your app inside IEx (Interactive Elixir) as: $ iex -S mix phx.server By default, Phoenix accepts requests on port 4000. If we point our favorite web browser at http://localhost:4000 , we should see the Phoenix Framework welcome page. If your screen looks like the image above, congratulations! You now have a working Phoenix application. In case you can't see the page above, try accessing it via http://127.0.0.1:4000 and later make sure your OS has defined &quot;localhost&quot; as &quot;127.0.0.1&quot;. To stop it, we hit ctrl-c twice. Now you are ready to explore the world provided by Phoenix! See our community page for books, screencasts, courses, and more. Alternatively, you can continue reading these guides to have a quick introduction into all the parts that make your Phoenix application. If that's the case, you can read the guides in any order or start with our guide that explains the Phoenix directory structure .","ref":"up_and_running.html","title":"Up and Running","type":"extras"}]